﻿import flash.filters.DropShadowFilter;
/**
* @author okm
* タグ一個分
*/
class Tag {
	private var parent:MovieClip;
	private var base:MovieClip;
	private var over:MovieClip;
	private var speed = 5;
	
	private var minSpeed:Number = 5;
	private var maxSpeed:Number = 10;
	
	private var tagField:TextField;
	private var tagFormat:TextFormat;
	
	public function Tag(parent:MovieClip, name:String, tag:String, size:Number, url:String ) {
		base = parent.createEmptyMovieClip(name, parent.getNextHighestDepth());
		
		tagFormat = new TextFormat;
		tagFormat.size = size;
		tagFormat.font = "_等幅";
		tagFormat.color = 0xFFFFFF;
		tagFormat.bold = true;
		base.createTextField("tagField_" + name, base.getNextHighestDepth(), 0, 0, 100, 100);
		tagField = base["tagField_" + name];
		tagField.autoSize = true;
		tagField.selectable = false;
		tagField.text = tag;
		tagField.setTextFormat(tagFormat);
		
		// フィルタ
		var param:DropShadowFilter = new DropShadowFilter();
		param.alpha = 0.9;
		param.angle = 45;
		param.blurX = 5;
		param.blurY = 5;
		param.color = 0x000000;
		param.distance = 2;
		param.strength = 1;
		param.quality = 2;
		param.inner = false;
		param.knockout = false;
		param.hideObject = false;
		this.tagField.filters = [param];
		
		// 文字をクリックした際にページジャンプするようにする
		over = base.createEmptyMovieClip(name + "over", base.getNextHighestDepth());
		over._alpha = 1;
		
		if(url != undefined){
			over.onPress = function() {
				getURL(url);
			}
		}
		over.lineStyle(1, 0x0000FF);
		over.beginFill(0x0000FF, 100);
		over.lineTo(tagField._width, 0);
		over.lineTo(tagField._width, tagField._height);
		over.lineTo(0, tagField._height);
		over.lineTo(0, 0);
		over.endFill();
	}
	
	// 漂い始める指示
	public function startCloud( random:Boolean ) {
		if (!isNaN(_root["minSpeed"])) minSpeed = Number(_root["minSpeed"]);
		if (!isNaN(_root["maxSpeed"])) maxSpeed = Number(_root["maxSpeed"]);
		
		this.speed = xRandomInt(minSpeed, maxSpeed);
		if (random) base._x = xRandomInt(0, Stage.width);
		else base._x = Stage.width;
		base._y = xRandomInt(0, Stage.height - tagField._height);
		var ref = this;
		base.onEnterFrame = function() {
			ref.onEnterHandler()
		}
	}
	
	public function onEnterHandler() {
		this.base._x -= this.speed;
		if (base._x < -tagField._width) {
			delete base.onEnterFrame;
			startCloud(false);
		}
	}
	
	public function set _x(x:Number) {
		base._x = x;
	}
	public function set _y(y:Number) {
		base._y = y;
	}

	function xRandomInt (nMax, nMin) {
		// nMinからnMaxまでのランダムな整数を返す
		var nRandomInt = Math.floor(Math.random()*(nMax-nMin+1))+nMin;
		return nRandomInt;
	}
} 